Loading...
Searching...
No Matches
Content-Disposition Header
MIME Headers

The Content-Disposition header field describes how the message body or, in the case of multipart messages, a message body part is to be interpreted by the UAC or UAS. More...

## Data Structures

struct | msg_content_disposition_s
| Structure for Content-Disposition header. More...

## Macros

#define | MSG_CONTENT_DISPOSITION_INIT()
| Initializer for an msg_content_disposition_t structure.

## Typedefs

typedef struct msg_content_disposition_s | msg_content_disposition_t
| The structure msg_content_disposition_t contains representation of an Content-Disposition header.

## Enumerations

enum | { msg_content_disposition_hash }

## Functions

msg_content_disposition_t * | msg_content_disposition_init (msg_content_disposition_t x[1])
| Initialize an msg_content_disposition_t structure.
int | msg_is_content_disposition (msg_header_t const *header)
| Test if header object is an instance of msg_content_disposition_t.
msg_content_disposition_t * | msg_content_disposition_dup (su_home_t *home, msg_content_disposition_t const *header)
| Duplicate (deep copy) msg_content_disposition_t.
msg_content_disposition_t * | msg_content_disposition_copy (su_home_t *home, msg_content_disposition_t const *header)
| Copy an msg_content_disposition_t header structure.
msg_content_disposition_t * | msg_content_disposition_make (su_home_t *home, char const *s)
| Make a header structure msg_content_disposition_t.
msg_content_disposition_t * | msg_content_disposition_format (su_home_t *home, char const *fmt,...)))
| Make a Content-Disposition header from formatting result.

## Variables

msg_parse_f | msg_content_disposition_d
| Parse a Content-Disposition header.
msg_print_f | msg_content_disposition_e
| Print a Content-Disposition header.
msg_hclass_t | msg_content_disposition_class []
| Header class for Content-Disposition header.

## Detailed Description

The Content-Disposition header field describes how the message body or, in the case of multipart messages, a message body part is to be interpreted by the UAC or UAS.

Its syntax is defined in [S20.11] as follows:

Content-Disposition = "Content-Disposition" ":"
disposition-type *( ";" disposition-param )
disposition-type = "render" | "session" | "icon" | "alert"
| disp-extension-token
disposition-param = "handling" "="
( "optional" | "required" | other-handling )
| generic-param
other-handling = token
disp-extension-token = token

The Content-Disposition header was extended by draft-lennox-sip-reg-payload-01.txt section 3.1 as follows:

Content-Disposition = "Content-Disposition" ":"
disposition-type *( ";" disposition-param )
disposition-type /= "script" | "sip-cgi" | token
disposition-param /= action-param
/ modification-date-param
action-param = "action" "=" action-value
action-value = "store" | "remove" | token
modification-date-param = "modification-date" "=" quoted-date-time
quoted-date-time = <"> SIP-date <">

## Macro Definition Documentation

## MSG_CONTENT_DISPOSITION_INIT

#define MSG_CONTENT_DISPOSITION_INIT | ( |  | ) |

Initializer for an msg_content_disposition_t structure.

A static msg_content_disposition_t structure must be initialized with the MSG_CONTENT_DISPOSITION_INIT() macro. For instance,

msg_content_disposition_t msg_content_disposition = MSG_CONTENT_DISPOSITION_INIT;
msg_content_disposition_t
struct msg_content_disposition_s msg_content_disposition_t
The structure msg_content_disposition_t contains representation of an Content-Disposition header.
Definition msg_mime.h:60
MSG_CONTENT_DISPOSITION_INIT
#define MSG_CONTENT_DISPOSITION_INIT()
Initializer for an msg_content_disposition_t structure.
Definition msg_mime_protos.h:352

## Typedef Documentation

## msg_content_disposition_t

typedef struct msg_content_disposition_s msg_content_disposition_t

The structure msg_content_disposition_t contains representation of an Content-Disposition header.

The msg_content_disposition_t is defined as follows:

typedef struct msg_content_disposition_s
{
msg_common_t cd_common[1]; // Common fragment info
msg_error_t *cd_next; // Link to next (dummy)
char const *cd_type; // Disposition type
msg_param_t const *cd_params; // List of parameters
msg_param_t cd_handling; // Value of @b handling parameter
unsigned cd_required:1; // True if handling=required
unsigned cd_optional:1; // True if handling=optional
} msg_content_disposition_t;
msg_error_t
struct msg_error_s msg_error_t
Type for erroneous headers.
Definition msg_types.h:94
msg_common_t
struct msg_common_s msg_common_t
Common part of header.
Definition msg_types.h:89
msg_content_disposition_s
Structure for Content-Disposition header.
Definition msg_mime.h:106
msg_content_disposition_s::cd_common
msg_common_t cd_common[1]
Common fragment info.
Definition msg_mime.h:107
msg_content_disposition_s::cd_optional
unsigned cd_optional
True if handling=optional.
Definition msg_mime.h:113
msg_content_disposition_s::cd_next
msg_error_t * cd_next
Link to next (dummy).
Definition msg_mime.h:108
msg_content_disposition_s::cd_type
char const * cd_type
Disposition type.
Definition msg_mime.h:109
msg_content_disposition_s::cd_required
unsigned cd_required
True if handling=required.
Definition msg_mime.h:112
msg_content_disposition_s::cd_handling
char const * cd_handling
Value of handling parameter.
Definition msg_mime.h:111
msg_content_disposition_s::cd_params
msg_param_t const * cd_params
List of parameters.
Definition msg_mime.h:110

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
msg_content_disposition_hash | Hash of Content-Disposition header.

## Function Documentation

## msg_content_disposition_copy()

msg_content_disposition_t * msg_content_disposition_copy | ( | su_home_t * | home,
|  | msg_content_disposition_t const * | header )

inline

Copy an msg_content_disposition_t header structure.

The function msg_content_disposition_copy() copies a header structure header. If the header structure header contains a reference (`header->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure header.

Parameters

  home | memory home used to allocate new structure
  header | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  content_disposition = msg_content_disposition_copy(home, msg->msg_content_disposition);
  msg_content_disposition_copy
  msg_content_disposition_t * msg_content_disposition_copy(su_home_t *home, msg_content_disposition_t const *header)
  Copy an msg_content_disposition_t header structure.
  Definition msg_mime_protos.h:481

Returns
  The function msg_content_disposition_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## msg_content_disposition_dup()

msg_content_disposition_t * msg_content_disposition_dup | ( | su_home_t * | home,
|  | msg_content_disposition_t const * | header )

inline

Duplicate (deep copy) msg_content_disposition_t.

The function msg_content_disposition_dup() duplicates a header structure header. If the header structure header contains a reference (`header->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  header | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  content_disposition = msg_content_disposition_dup(home, msg->msg_content_disposition);
  msg_content_disposition_dup
  msg_content_disposition_t * msg_content_disposition_dup(su_home_t *home, msg_content_disposition_t const *header)
  Duplicate (deep copy) msg_content_disposition_t.
  Definition msg_mime_protos.h:436

Returns
  The function msg_content_disposition_dup() returns a pointer to the newly duplicated msg_content_disposition_t header structure, or NULL upon an error.

## msg_content_disposition_format()

msg_content_disposition_t * msg_content_disposition_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Content-Disposition header from formatting result.

The function msg_content_disposition_format() makes a new Content-Disposition header object using snprintf-formatted result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function may be implemented as a macro calling msg_header_format().

Returns
  The function msg_content_disposition_format() returns a pointer to newly makes header structure, or NULL upon an error.

## msg_content_disposition_init()

msg_content_disposition_t * msg_content_disposition_init | ( | msg_content_disposition_t | x[1] | ) |

inline

Initialize an msg_content_disposition_t structure.

An msg_content_disposition_t structure can be initialized with the msg_content_disposition_init() function/macro. For instance,

msg_content_disposition_t msg_content_disposition;
msg_content_disposition_init(&msg_content_disposition);
msg_content_disposition_init
msg_content_disposition_t * msg_content_disposition_init(msg_content_disposition_t x[1])
Initialize an msg_content_disposition_t structure.
Definition msg_mime_protos.h:369

Parameters

  x | pointer to msg_content_disposition_t structure

## msg_content_disposition_make()

msg_content_disposition_t * msg_content_disposition_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure msg_content_disposition_t.

The function msg_content_disposition_make() makes a new msg_content_disposition_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function may be implemented as a macro calling msg_header_make().

Returns
  The function msg_content_disposition_make() returns a pointer to newly maked msg_content_disposition_t header structure, or NULL upon an error.

## msg_is_content_disposition()

int msg_is_content_disposition | ( | msg_header_t const * | header | ) |

inline

Test if header object is an instance of msg_content_disposition_t.

The function msg_is_content_disposition() returns true (nonzero) if the header class is an instance of Content-Disposition header object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function msg_is_content_disposition() returns true (nonzero) if the header object is an instance of header Content-Disposition header and false (zero) otherwise.

## Variable Documentation

## msg_content_disposition_class

msg_hclass_t msg_content_disposition_class[]

extern

Header class for Content-Disposition header.

The header class msg_content_disposition_class defines how a Content-Disposition header header is parsed and printed. It also contains methods used by message parser and other functions to manipulate the msg_content_disposition_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.